/*
**
**                           Main.c
**
**
**********************************************************************/
/*
   Last committed:     $Revision: 00 $
   Last changed by:    $Author: $
   Last changed date:  $Date:  $
   ID:                 $Id:  $

**********************************************************************/
#include "stm32f0xx_conf.h"


void TimConfg(void) //  .
{
    TIM_TimeBaseInitTypeDef Tim;
    NVIC_InitTypeDef NVIC_I;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM14, ENABLE); //   TIM14.

    Tim.TIM_ClockDivision = TIM_CKD_DIV1; //     .
    Tim.TIM_CounterMode   = TIM_CounterMode_Up; //     .
    Tim.TIM_Prescaler     = (SystemCoreClock / 1000) - 1; //       1 .
    Tim.TIM_Period        = 499; //     2   .
    Tim.TIM_RepetitionCounter = 0;

    TIM_TimeBaseInit(TIM14, &Tim); //  .

    //    .
    NVIC_I.NVIC_IRQChannel = TIM14_IRQn;
    NVIC_I.NVIC_IRQChannelPriority = 3; //   (0 - 3. 0 - , 3 - ).
    NVIC_I.NVIC_IRQChannelCmd = ENABLE; //  .
    NVIC_Init(&NVIC_I);

    TIM_ITConfig(TIM14, TIM_IT_Update, ENABLE); //     .

    TIM_Cmd(TIM14, ENABLE); //  .

}


int main(void)
{

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);  //   GPIOB.

    {
        GPIO_InitTypeDef GPIO_InitStruct;

        GPIO_InitStruct.GPIO_Pin = GPIO_Pin_1;        //   PB1.
        GPIO_InitStruct.GPIO_Mode = GPIO_Mode_OUT;    //    .
        GPIO_InitStruct.GPIO_OType = GPIO_OType_PP;   //   (. .   ).
        GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL; //   .
        GPIO_InitStruct.GPIO_Speed = GPIO_Speed_10MHz;

        GPIO_Init(GPIOB, &GPIO_InitStruct);           //  .
    }

    SystemCoreClockUpdate(); //    .
    TimConfg();              //  .


    while(1)
    {
        PWR_EnterSleepMode(PWR_SLEEPEntry_WFI); //     .
    }
}


void GPIO_TogglePin(GPIO_TypeDef* GPIOx, uint16_t Pin) //    .
{
    GPIOx->ODR ^= Pin;
}


void TIM14_IRQHandler(void) //    .
{
    GPIO_TogglePin(GPIOB, GPIO_Pin_1);           //  .
    TIM_ClearITPendingBit(TIM14, TIM_IT_Update); //      .
}
